"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _1 = require("./");
var utils_1 = require("./utils");
var ALL = '__ALL__';
function connect(store) {
    return function (Component) {
        var _a;
        return _a = /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.state = {
                        store: new _1.StoreSnapshotWithSubscription(store.getCurrentSnapshot(), _this.onGet.bind(_this), _this.onGetAll.bind(_this)),
                        subscriptions: {}
                    };
                    return _this;
                }
                class_1.prototype.onChange = function (key, value) {
                    if (utils_1.equals(value, this.state.store.get(key))) {
                        return;
                    }
                    this.setState({
                        store: new _1.StoreSnapshotWithSubscription(store.getCurrentSnapshot(), // TODO: Can we replace Snapshot with SnapshotWithSub?
                        this.onGet.bind(this), this.onGetAll.bind(this))
                    });
                };
                class_1.prototype.onGet = function (key) {
                    if (key in this.state.subscriptions || ALL in this.state.subscriptions) {
                        return;
                    }
                    // Hacky direct write to state, for performance
                    this.state.subscriptions[key] = store.on(key).subscribe(this.onChange.bind(this, key));
                };
                class_1.prototype.onGetAll = function () {
                    var _this = this;
                    var _a;
                    if (ALL in this.state.subscriptions) {
                        return;
                    }
                    // Clear per-key subscriptions
                    // TODO: Find a way to test this. React batches render() calls,
                    // so it's hard to test that this actually prevents extra re-renders.
                    this.clearSubscriptions();
                    // Hacky direct write to state, for performance
                    this.state.subscriptions = (_a = {},
                        _a[ALL] = store.onAll().subscribe(function (_a) {
                            var key = _a.key, value = _a.value;
                            return _this.onChange(key, value);
                        }),
                        _a); // TODO
                };
                class_1.prototype.clearSubscriptions = function () {
                    utils_1.mapValues(this.state.subscriptions, function (_) { return _.unsubscribe(); });
                };
                class_1.prototype.componentWillUnmount = function () {
                    this.clearSubscriptions();
                };
                class_1.prototype.shouldComponentUpdate = function (props, state) {
                    var _this = this;
                    return state.store !== this.state.store
                        || Object.keys(props).some(function (_) { return props[_] !== _this.props[_]; });
                };
                class_1.prototype.render = function () {
                    return React.createElement(Component, __assign({}, this.props, { store: this.state.store }));
                };
                return class_1;
            }(React.Component)),
            _a.displayName = "withStore(" + utils_1.getDisplayName(Component) + ")",
            _a;
    };
}
exports.connect = connect;
function connectAs(stores) {
    return function (Component) {
        var _a;
        return _a = /** @class */ (function (_super) {
                __extends(class_2, _super);
                function class_2() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.state = {
                        stores: utils_1.mapValues(stores, function (_) {
                            return _.getCurrentSnapshot();
                        }),
                        subscriptions: utils_1.keys(stores).map(function (k) {
                            return stores[k].onAll().subscribe(function (_a) {
                                var previousValue = _a.previousValue, value = _a.value;
                                var _b;
                                if (utils_1.equals(previousValue, value)) {
                                    return false;
                                }
                                _this.setState({
                                    stores: Object.assign({}, _this.state.stores, (_b = {}, _b[k] = stores[k].getCurrentSnapshot(), _b))
                                });
                            });
                        })
                    };
                    return _this;
                }
                class_2.prototype.componentWillUnmount = function () {
                    this.state.subscriptions.forEach(function (_) { return _.unsubscribe(); });
                };
                class_2.prototype.shouldComponentUpdate = function (props, state) {
                    var _this = this;
                    return utils_1.some(state.stores, function (s, k) { return s !== _this.state.stores[k]; })
                        || Object.keys(props).some(function (_) { return props[_] !== _this.props[_]; });
                };
                class_2.prototype.render = function () {
                    return React.createElement(Component, __assign({}, this.props, this.state.stores));
                };
                return class_2;
            }(React.Component)),
            _a.displayName = "withStore(" + utils_1.getDisplayName(Component) + ")",
            _a;
    };
}
exports.connectAs = connectAs;
//# sourceMappingURL=react.js.map